#!/usr/bin/python

import sys

def get_left_free(gl):
    r = 100
    for l in gl:
        fr = 0
        for c in l:
            if c=='-':
                fr+=1
            else:
                break
        if fr<r:
            r = fr
    if r==len(gl[0]):
        return r/4
    return r


def get_right_free(gl):
    r = 100
    for l in gl:
        fr = 0
        for c in l[::-1]:
            if c=='-':
                fr+=1
            else:
                break
        if fr<r:
            r = fr
    if r==len(gl[0]):
        return r/4

    return r

limitl = 0
limitr = 1

def make_narrow(gl):
    lf = get_left_free(gl)
    rf = get_right_free(gl)
    cutl = cutr = 0
    if lf>limitl:
        cutl = lf-limitl
    if rf>limitr:
        cutr = rf-limitr
    r = []
    for l in gl:
        r.append(l[cutl:len(l)-cutr])
    return r        


f = file(sys.argv[1])
glyphs = {}
glyph = []
preamble = []
glyphn = None
for l in f:
    if l.startswith('//') or not l.strip():
        continue
    if l.startswith('GLYPH'):
        if glyphn <> None:
            glyphs[glyphn] = glyph
            glyph = []
            glyphn = None
        glyphn = int(l.strip().split()[1])
    elif glyphn<>None:
        glyph.append(l.strip())
    if glyphn==None:
        preamble.append(l.strip())

glyphs[glyphn] = glyph

for p in preamble:
    print p

glk = glyphs.keys()
glk.sort()
for gl in glk:
    print "GLYPH", gl
    for l in make_narrow(glyphs[gl]):
        print l
    print
    